package com.zmkm.shop.base.controller;

import com.zmkm.shop.constant.ResultCodeEnum;
import com.zmkm.shop.base.result.BaseResult;
import org.apache.shiro.authz.UnauthorizedException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * @description：基础 controller
 */
@ControllerAdvice
public abstract class BaseController {

	private static Logger logger = LoggerFactory.getLogger(BaseController.class);

	@InitBinder
	public void initBinder(ServletRequestDataBinder binder) {
	}

	@ExceptionHandler({ Exception.class })
	@ResponseBody
	public BaseResult<Object> exception(Exception e) {
		logger.error("", e);
		BaseResult<Object> result = new BaseResult<Object>();
		result.setCode(ResultCodeEnum.HTTP_ERROR.getCode());
		result.setMsg(e.getMessage());
		return result;
	}
//	@ExceptionHandler({
//			UnknownAccountException.class, IncorrectCredentialsException.class
//	})
//	@ResponseStatus(HttpStatus.UNAUTHORIZED)
//	public BaseResult loginException(Exception exception) {
//		return new BaseResult(HttpStatus.UNAUTHORIZED.value(),exception.getMessage());
//	}
	@ExceptionHandler({
			UnauthorizedException.class
	})
	@ResponseBody
	public BaseResult unauthorizedException(Exception exception) {
		BaseResult<Object> result = new BaseResult<Object>();
		result.setCode(ResultCodeEnum.HTTP_ERROR.getCode());
		result.setMsg(ResultCodeEnum.HTTP_USER_UNAUTHORIZED.getMsg());
		return result;
	}
}
