package com.zmkm.shop.config.dozer;

import com.github.dozermapper.core.Mapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.stream.Collectors;
@Component
public class DozerMapperFactory {
    @Autowired
    private Mapper dozerMapper;

    public <T, S> T convert(S s, Class<T> clz) {
        return s == null ? null : dozerMapper.map(s, clz);
    }

    public <T, S> List<T> convert(List<S> s, Class<T> clz) {
        return s == null ? null : s.stream().map(vs -> dozerMapper.map(vs, clz)).collect(Collectors.toList());
    }
}
