package com.zmkm.shop.config.mybatis;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.zmkm.shop.base.domain.BaseUserNameTime;
import org.apache.ibatis.reflection.MetaObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.util.Objects;
import java.util.function.Supplier;

@Component
public class AutoDataHandler implements MetaObjectHandler {

    private static final Logger LOGGER = LoggerFactory.getLogger(AutoDataHandler.class);
    private static final String DEFAULT_CREATETIME_NAME = "createTime";

    private static final String DEFAULT_UPDATETIME_NAME = "updateTime";

    private static final String DEFAULT_OPERATOR_NAME = "operator";

    private static final String DEFAULT_OPERATOR_NAME_NAME = "operatorName";
    @Override
    public void insertFill(MetaObject metaObject) {
        LOGGER.info("start insert fill ....");
        Long id=1L;
        String loginName="admin1";
        if (metaObject.getOriginalObject() instanceof BaseUserNameTime) {
            this.strictInsertFill(metaObject,DEFAULT_OPERATOR_NAME,Long.class,id);
            this.strictInsertFill(metaObject,DEFAULT_OPERATOR_NAME_NAME,String.class,loginName);
            this.strictInsertFill(metaObject, DEFAULT_CREATETIME_NAME,Long.class, System.currentTimeMillis());
            this.strictInsertFill(metaObject, DEFAULT_UPDATETIME_NAME,Long.class, System.currentTimeMillis());
        }
    }

    @Override
    public void updateFill(MetaObject metaObject) {
        LOGGER.info("start update fill ....");
        Long id=3L;
        String loginName="admin3";
        if (metaObject.getOriginalObject() instanceof BaseUserNameTime) {
            this.strictUpdateFill(metaObject,DEFAULT_OPERATOR_NAME,Long.class,id);
            this.strictUpdateFill(metaObject,DEFAULT_OPERATOR_NAME_NAME,String.class,loginName);
            this.strictUpdateFill(metaObject, DEFAULT_CREATETIME_NAME,Long.class, System.currentTimeMillis());
            this.strictUpdateFill(metaObject, DEFAULT_UPDATETIME_NAME,Long.class, System.currentTimeMillis());
        }
    }

    @Override
    public MetaObjectHandler strictFillStrategy(MetaObject metaObject, String fieldName, Supplier<?> fieldVal) {
        Object obj = fieldVal.get();
        if (Objects.nonNull(obj)) {
            metaObject.setValue(fieldName, obj);
        }
        return this;
    }
}
