package com.zmkm.shop.config.shiro;

import com.zmkm.shop.config.shiro.cache.ShiroSpringCacheManager;
import org.springframework.cache.caffeine.CaffeineCacheManager;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.serializer.StringRedisSerializer;

/**
 * @author sonny
 *
 */
@Configuration
@SuppressWarnings({ "rawtypes", "unchecked" })
public class CacheConfig {

	@Bean
	public CaffeineCacheManager getGuavaCacheManager() {
		CaffeineCacheManager caffeineCacheManager = new CaffeineCacheManager();
		caffeineCacheManager.setCacheSpecification("expireAfterAccess=30m");
		return caffeineCacheManager;
	}

	@Bean
	public ShiroSpringCacheManager getShiroSpringCacheManager(RedisTemplate redisTemplate, CaffeineCacheManager caffeineCacheManager) {
		redisTemplate.setKeySerializer(new StringRedisSerializer());
		ShiroSpringCacheManager shiroSpringCacheManager = new ShiroSpringCacheManager();
		shiroSpringCacheManager.setCaffeineCacheManager(caffeineCacheManager);
		shiroSpringCacheManager.setRedisTemplate(redisTemplate);
		return shiroSpringCacheManager;
	}

}