package com.zmkm.shop.config.shiro;

import com.zmkm.shop.config.shiro.session.ShiroSessionFactory;
import com.zmkm.shop.filter.AllowOptionsFormAuthenticationFilter;
import com.zmkm.shop.filter.URLPermissionsFilter;
import com.zmkm.shop.utils.ShiroUtils;
import org.apache.shiro.authc.credential.HashedCredentialsMatcher;
import org.apache.shiro.cache.CacheManager;
import org.apache.shiro.mgt.SecurityManager;
import org.apache.shiro.spring.LifecycleBeanPostProcessor;
import org.apache.shiro.spring.security.interceptor.AuthorizationAttributeSourceAdvisor;
import org.apache.shiro.spring.web.ShiroFilterFactoryBean;
import org.apache.shiro.web.mgt.DefaultWebSecurityManager;
import org.apache.shiro.web.servlet.SimpleCookie;
import org.apache.shiro.web.session.mgt.DefaultWebSessionManager;
import org.springframework.aop.framework.autoproxy.DefaultAdvisorAutoProxyCreator;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.DependsOn;

import javax.servlet.Filter;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;

//@Configuration
public class ShiroConfig {
//
//	@Bean
//	public ShiroFilterFactoryBean shiroFilter(SecurityManager securityManager) {
//		ShiroFilterFactoryBean shiroFilterFactoryBean = new ShiroFilterFactoryBean();
//		shiroFilterFactoryBean.setSecurityManager(securityManager);
//		Map<String, String> filterChainDefinitionMap = new LinkedHashMap<String, String>();
//		// for api docs
//		filterChainDefinitionMap.put("/swagger-ui.html", "anon");
//		filterChainDefinitionMap.put("/swagger-resources/**", "anon");
//		filterChainDefinitionMap.put("/v2/api-docs", "anon");
//		filterChainDefinitionMap.put("/webjars/springfox-swagger-ui/**", "anon");
//		// for biz
//		filterChainDefinitionMap.put("/test", "anon");
////		filterChainDefinitionMap.put("/**", "userFilter,urlFilter");
//		shiroFilterFactoryBean.setLoginUrl("/loginUrl");
//		shiroFilterFactoryBean.setSuccessUrl("");
//		shiroFilterFactoryBean.setUnauthorizedUrl("/unauthorizedUrl");
//
//		Map<String, Filter> filterMap = new HashMap<>();
////		filterMap.put("urlFilter", new URLPermissionsFilter());
////		filterMap.put("userFilter", new AllowOptionsFormAuthenticationFilter());
//		shiroFilterFactoryBean.setFilters(filterMap);
//		shiroFilterFactoryBean.setFilterChainDefinitionMap(filterChainDefinitionMap);
//		return shiroFilterFactoryBean;
//	}
//
//	@Bean
//	public SecurityManager securityManager(CacheManager cacheManager, DefaultWebSessionManager defaultWebSessionManager , ShiroDbRealm shiroDbRealm) {
//		DefaultWebSecurityManager securityManager = new DefaultWebSecurityManager();
//		securityManager.setCacheManager(cacheManager);
//		securityManager.setRealm(shiroDbRealm);
//		securityManager.setSessionManager(defaultWebSessionManager);
//		return securityManager;
//	}
//
//	@Bean
//	public DefaultWebSessionManager sessionManager(CachingShiroSessionDao cachingShiroSessionDao , SimpleCookie simpleCookie) {
//		DefaultWebSessionManager manager = new ShiroSessionManager();
//		manager.setSessionDAO(cachingShiroSessionDao);
//		manager.setGlobalSessionTimeout(1000 * 60 * 60 * 24);
//		manager.setSessionValidationSchedulerEnabled(false);
//		manager.setSessionIdCookie(simpleCookie);
//		manager.setSessionIdCookieEnabled(true);
//		manager.setSessionIdUrlRewritingEnabled(false);
//		manager.setSessionFactory(new ShiroSessionFactory());
//		return manager;
//	}
//
//	@Bean
//	public CachingShiroSessionDao sessionDao() {
//		CachingShiroSessionDao sessionDao = new CachingShiroSessionDao();
//		sessionDao.setActiveSessionsCacheName("pasc");
//		return sessionDao;
//	}
//
//	@Bean
//	public SimpleCookie sessionIdCookie() {
//		SimpleCookie cookie =  new SimpleCookie("com-zmkm-shop-token");
//		cookie.setHttpOnly(false);
//		cookie.setSameSite(null);
//		return cookie;
//	}
//
//	@Bean
//	public ShiroDbRealm ShiroRealm(HashedCredentialsMatcher hashedCredentialsMatcher) {
//		ShiroDbRealm shiroDbRealm = new ShiroDbRealm();
//		shiroDbRealm.setCredentialsMatcher(hashedCredentialsMatcher);
//		shiroDbRealm.setAuthorizationCacheName("pacn");
//		return shiroDbRealm;
//	}
//
//	@Bean
//	public HashedCredentialsMatcher hashedCredentialsMatcher() {
//		HashedCredentialsMatcher hashedCredentialsMatcher = new HashedCredentialsMatcher();
//		hashedCredentialsMatcher.setHashAlgorithmName(ShiroUtils.algorithmName);
//		hashedCredentialsMatcher.setHashIterations(ShiroUtils.hashIterations);
//		return hashedCredentialsMatcher;
//	}
//
//	@Bean
//	public LifecycleBeanPostProcessor lifecycleBeanPostProcessor() {
//		return new LifecycleBeanPostProcessor();
//	}
//
//	@Bean
//	@DependsOn({ "lifecycleBeanPostProcessor" })
//	public DefaultAdvisorAutoProxyCreator advisorAutoProxyCreator() {
//		DefaultAdvisorAutoProxyCreator advisorAutoProxyCreator = new DefaultAdvisorAutoProxyCreator();
//		advisorAutoProxyCreator.setProxyTargetClass(true);
//		return advisorAutoProxyCreator;
//	}
//
//	@Bean
//	public AuthorizationAttributeSourceAdvisor authorizationAttributeSourceAdvisor(SecurityManager securityManager) {
//		AuthorizationAttributeSourceAdvisor authorizationAttributeSourceAdvisor = new AuthorizationAttributeSourceAdvisor();
//		authorizationAttributeSourceAdvisor.setSecurityManager(securityManager);
//		return authorizationAttributeSourceAdvisor;
//	}
}