package com.zmkm.shop.modules.test.domain;

import lombok.Data;
import lombok.AllArgsConstructor;
import lombok.NoArgsConstructor;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;

/**
* @Title: NetReceiveAddress
* @Package com.zmkm.shop.domain
* @Description: 小程序收货人地址表
* @author 40873
* @date 2024-2-14
*/
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "t_net_receive_address")
public class NetReceiveAddress {

    @TableId(value = "id",type = IdType.AUTO)
    private Long id;//主键——>id

    @TableField(value = "c_phone")
    private String cPhone;//用户手机号——>c_phone

    @TableField(value = "receive_name")
    private String receiveName;//姓名——>receive_name

    @TableField(value = "receive_phone")
    private String receivePhone;//电话——>receive_phone

    @TableField(value = "pro_code")
    private String proCode;//省代码——>pro_code

    @TableField(value = "pro_name")
    private String proName;//省名称——>pro_name

    @TableField(value = "city_code")
    private String cityCode;//市代码——>city_code

    @TableField(value = "city_name")
    private String cityName;//市名称——>city_name

    @TableField(value = "area_code")
    private String areaCode;//区代码——>area_code

    @TableField(value = "area_name")
    private String areaName;//区名称——>area_name

    @TableField(value = "village_type")
    private Integer villageType;//街道类型|1：机构；2：目的地——>village_type

    @TableField(value = "village_id")
    private Long villageId;//乡id——>village_id

    @TableField(value = "village_name")
    private String villageName;//乡名称——>village_name

    @TableField(value = "address")
    private String address;//详细地址——>address

    @TableField(value = "shop_name")
    private String shopName;//公司/店名——>shop_name

    @TableField(value = "status")
    private Integer status;//状态：1.有效|2.无效——>status

    @TableField(value = "lon")
    private String lon;//经度——>lon

    @TableField(value = "lat")
    private String lat;//纬度——>lat

    @TableField(value = "operator")
    private Long operator;//操作人员——>operator

    @TableField(value = "create_time")
    private Long createTime;//创建时间——>create_time

    @TableField(value = "update_time")
    private Long updateTime;//操作时间——>update_time

    @TableField(value = "receive_status")
    private Integer receiveStatus;//1需自提 2可派送 默认 0——>receive_status

    @TableField(value = "operator_name")
    private String operatorName;//操作人姓名——>operator_name
}
