package com.zmkm.shop.modules.test.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

/**
* @Title: Organization
* @Package com.zmkm.shop.domain
* @Description: 机构
* @author 40873
* @date 2024-2-14
*/
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "t_organization")
public class Organization  {

    @TableId(value = "id",type = IdType.AUTO)
    private Long id;//主键id——>id

    @TableField(value = "p_id")
    private Long pId;//上级机构id——>p_id

    @TableField(value = "name")
    private String name;//机构名称——>name

    @TableField(value = "short_name")
    private String shortName;//机构简称，手填 例如沈阳区域 2A 5A 等等 有规则，不可以重复 可以自动生成 例如排到了5A 自动生成6A 如果在已生成的简称里1A-50A 之间有33A被停用了，再生成的时候先生成33A 下一个再生成51A，另外可以不用默认生成的简称自己添加——>short_name

    @TableField(value = "telephone")
    private String telephone;//固定电话——>telephone

    @TableField(value = "manager_name")
    private String managerName;//经理姓名——>manager_name

    @TableField(value = "manager_phone")
    private String managerPhone;//经理手机——>manager_phone

    @TableField(value = "esc_manager_name")
    private String escManagerName;//代管经理姓名——>esc_manager_name

    @TableField(value = "esc_manager_phone")
    private String escManagerPhone;//代管经理手机号——>esc_manager_phone

    @TableField(value = "operate_type")
    private Integer operateType;//经营类型|1:直营;2:承包——>operate_type

    @TableField(value = "org_type")
    private Integer orgType;//机构类型|1, 普通机构, 2,大区机构, 3,大区域, 4, 小区域, 5, 中转机构, 6, 内埠, 7, 外埠, 8, 收发货机构，9.分拨中心，10.返货组;——>org_type

    @TableField(value = "allow_delivery")
    private Integer allowDelivery;//允许发货|1:允许 2:不允许;——>allow_delivery

    @TableField(value = "allow_receive")
    private Integer allowReceive;//允许到货|1:允许 2:不允许;——>allow_receive

    @TableField(value = "distance")
    private Integer distance;//运距（公里）此为内埠站点到租车场的运距，据了解未来可能有多个租车场，但不会交叉，内埠站点只到固定的一个租车场——>distance

    @TableField(value = "delivery_day_occupy")
    private BigDecimal deliveryDayOccupy;//发货日提点，百分比——>delivery_day_occupy

    @TableField(value = "receive_day_occupy")
    private BigDecimal receiveDayOccupy;//到货日提点，百分比——>receive_day_occupy

    @TableField(value = "province")
    private String province;//省——>province

    @TableField(value = "city")
    private String city;//市——>city

    @TableField(value = "area")
    private String area;//区——>area

    @TableField(value = "send_time")
    private Long sendTime;//外埠发车时间——>send_time

    @TableField(value = "address")
    private String address;//机构地址——>address

    @TableField(value = "longitude")
    private String longitude;//经度——>longitude

    @TableField(value = "latitude")
    private String latitude;//纬度——>latitude

    @TableField(value = "section")
    private Long section;//所属区域——>section

    @TableField(value = "inout_mark")
    private Integer inoutMark;//标记机构内外埠：1内埠 2外埠 3其他——>inout_mark

    @TableField(value = "status")
    private Integer status;//是否启用|1:启用;2:禁用;3:停用;——>status

    @TableField(value = "remark")
    private String remark;//备注——>remark

    @TableField(value = "order_code")
    private Integer orderCode;//排序——>order_code

    @TableField(value = "city_num")
    private String cityNum;//城市固定电话区号——>city_num

    @TableField(value = "opening_day")
    private Long openingDay;//开业时间——>opening_day

    @TableField(value = "wx_push_flag")
    private Integer wxPushFlag;//微信推送标识：1推送、2不推送——>wx_push_flag

    @TableField(value = "rural")
    private Integer rural;//是否二级 1 否 2 是——>rural

    @TableField(value = "rural_parent_id")
    private Long ruralParentId;//一级父机构id——>rural_parent_id

    @TableField(value = "operator")
    private Long operator;//操作人员——>operator

    @TableField(value = "operator_name")
    private String operatorName;//操作人——>operator_name

    @TableField(value = "create_time")
    private Long createTime;//创建时间——>create_time

    @TableField(value = "update_time")
    private Long updateTime;//操作时间——>update_time

    @TableField(value = "pro_code")
    private String proCode;//发货省代码——>pro_code

    @TableField(value = "city_code")
    private String cityCode;//发货市代码——>city_code

    @TableField(value = "area_code")
    private String areaCode;//发货区代码——>area_code

    @TableField(value = "amap_flag")
    private Integer amapFlag;//小程序地图是否显示；1：显示|2不显示——>amap_flag

    @TableField(value = "center_id")
    private Long centerId;//分拨中心id ——>center_id

    @TableField(value = "center_line_id")
    private Long centerLineId;//所属分拣线id ——>center_line_id

    @TableField(value = "return_id")
    private Long returnId;//所属返货组id ——>return_id

    @TableField(value = "theater_id")
    private Long theaterId;//所属战区id ——>theater_id

    @TableField(value = "gid_type")
    private Integer gidType;//配送范围配置|1:已配置;2:未配置——>gid_type

    @TableField(value = "gid")
    private String gid;//电子围栏——>gid

    @TableField(value = "online")
    private Integer online;//网上下单是否显示|1:显示;2:不显示——>online

    @TableField(value = "sign")
    private Integer sign;//签收限制开关|1:开;2:关——>sign

    @TableField(value = "alarm_value")
    private Integer alarmValue;//警戒值：0-1000000——>alarm_value

    @TableField(value = "alarm_lock")
    private Integer alarmLock;//警戒值锁定(%)——>alarm_lock

    @TableField(value = "project_line")
    private Integer projectLine;//每日到货货款额度——>project_line

    @TableField(value = "day")
    private String day;//提现日（多个日期用英文逗号分隔）——>day

    @TableField(value = "day_type")
    private Integer dayType;//提现方式 1每周提现 2每月提现——>day_type

    @TableField(value = "freight_type")
    private Integer freightType;//是否扣运费 1是 2否——>freight_type

    @TableField(value = "goods_type")
    private Integer goodsType;//是否扣货款 1是 2否——>goods_type
}
