package com.zmkm.shop.modules.test.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.zmkm.shop.base.result.BaseResult;
import com.zmkm.shop.base.service.impl.BaseServiceImpl;
import com.zmkm.shop.config.dozer.DozerMapperFactory;
import com.zmkm.shop.modules.test.domain.Dict;
import com.zmkm.shop.modules.test.domain.NetReceiveAddress;
import com.zmkm.shop.modules.test.domain.NetReceiveAddressCopy1;
import com.zmkm.shop.modules.test.domain.Organization;
import com.zmkm.shop.modules.test.mapper.DictMapper;
import com.zmkm.shop.modules.test.mapper.NetReceiveAddressCopy1Mapper;
import com.zmkm.shop.modules.test.mapper.NetReceiveAddressMapper;
import com.zmkm.shop.modules.test.mapper.OrganizationMapper;
import com.zmkm.shop.modules.test.service.DictService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class DictServiceImpl extends BaseServiceImpl<DictMapper, Dict>  {
    @Autowired
    private NetReceiveAddressMapper netReceiveAddressMapper;
    @Autowired
    private NetReceiveAddressCopy1Mapper receiveAddressCopy1Mapper;
    @Autowired
    private OrganizationMapper organizationMapper;
    @Autowired
    DozerMapperFactory dozer;
    @Transactional(rollbackFor = Exception.class)
    public BaseResult<Object> receiveDataSyn(){
        List<NetReceiveAddressCopy1> list = receiveAddressCopy1Mapper. selectList(
                new QueryWrapper<NetReceiveAddressCopy1>().lambda().eq(NetReceiveAddressCopy1::getStatus,1)
        );

        for(NetReceiveAddressCopy1 copy1 : list) {
            NetReceiveAddress domain = dozer.convert(copy1,NetReceiveAddress.class);


            List<Organization> orgList = organizationMapper.selectList(
              new QueryWrapper<Organization>().lambda().eq(Organization::getProvince,copy1.getProName())
                      .eq(Organization::getCity,copy1.getCityName())
                      .eq(Organization::getArea,copy1.getAreaName())
                      .eq(Organization::getStatus,1)
            );

            if(CollectionUtils.isNotEmpty(orgList) && orgList.size() == 1) {
                Long orgid =  orgList.get(0).getId();
                domain.setVillageType(1);
                domain.setVillageId(orgid);
            }
            netReceiveAddressMapper.insert(domain);
        }
        return new BaseResult<>();
    }
}
