package com.zmkm.shop.utils;

import org.apache.commons.codec.binary.Hex;
import org.apache.commons.lang3.RandomUtils;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.crypto.hash.SimpleHash;
import org.apache.shiro.subject.Subject;

/**
 * 查询源码，发现shiro有原生加密方式，舍弃自定义
 * @author shen
 *
 */
public class ShiroUtils {

	public final static String algorithmName = "MD5";
	public static final int hashIterations= 10;
	/**
	* @Title: generateSalt
	* @Description: TODO(生成随机)
	* @param @param saltNum
	* @param @return
	* @return String
	* @throws
	*/
	public static String generateSalt(int saltNum) {
		return new String(Hex.encodeHex(RandomUtils.nextBytes(saltNum)));
	}
	/**
	 * 加密
	 * @param password
	 * @param salt
	 * @return
	 */
	public static String EncodeSalt(String password, String salt) {
		return new SimpleHash(algorithmName, password, salt, hashIterations).toString();
	}
	/**
	* @Title: getSubject
	* @Description: TODO(获取Subject)
	* @param @return
	* @return Subject
	* @throws
	*/
	public static Subject getSubject() {
		return SecurityUtils.getSubject();
	}

	public static void main(String[] args) {
		System.out.println(EncodeSalt("123456","87ee72d4154d262d"));
	}
}
